<template>
  <v-app>
    <v-app-bar>
      <router-link to="/" style="width: 155px">
        <v-img :src="store.logoUrl" contain class="ml-4 mr-2" />
      </router-link>
      <v-app-bar-title class="mx-2">{{ $t(`${String($route.name)}.title`) }}</v-app-bar-title>

      <template #append>
        <div class="d-none d-sm-block mx-2">{{ store.user?.displayname }}</div>

        <v-switch
          class="fill-height mt-2 mx-2"
          :model-value="theme.global.name.value"
          true-value="dark"
          true-icon="fas fa-moon"
          false-value="light"
          false-icon="fas fa-sun"
          inset
          @update:model-value="updateTheme($event)"
        />

        <div class="mx-2">
          <v-menu v-model="localeSelectMenuOpened">
            <template #activator="{ props }">
              <v-btn v-bind="props" class="px-0">
                <v-img :src="localeSvgUrl" width="32" class="mr-2" />
                <v-icon icon="fas fa-caret-down" />
              </v-btn>
            </template>
            <v-list density="compact">
              <v-list-item
                v-for="locale in $i18n.availableLocales"
                :key="`locale-${locale}`"
                @click="$i18n.locale = locale"
              >
                <template #prepend>
                  <v-img :src="getLocaleFlagUrl(locale)" width="24" class="mr-2" />
                </template>
                <v-list-item-title>
                  {{ new Intl.DisplayNames([$i18n.locale], { type: "language" }).of(locale) }}
                </v-list-item-title>
              </v-list-item>
            </v-list>
          </v-menu>
        </div>
      </template>
    </v-app-bar>

    <v-main>
      <v-dialog v-model="apiErrorDialogOpened" width="auto" max-width="1000">
        <v-card v-if="store.apiErrorDialogData" class="pa-2">
          <v-card-title class="text-center">
            {{ $t("errors.api.title") }}
          </v-card-title>
          <v-card-text prepend-icon="fas fa-exclamation-triangle">
            <div class="d-flex">
              <div class="align-content-center pr-4">
                <v-icon icon="fas fa-circle-xmark" color="red"></v-icon>
              </div>
              <div>
                <div class="font-weight-bold">
                  {{ $t(store.apiErrorDialogData.prefixI18nId) }}
                </div>
                <div>
                  {{ store.apiErrorDialogData.apiError.getLocalized($t) }}
                </div>
              </div>
            </div>
          </v-card-text>
          <v-card-actions>
            <v-btn color="secondary" block @click="store.apiErrorDialogData = null">
              {{ $t("dialog.closeButton") }}
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <v-dialog v-model="backendErrorDialogOpened" width="auto" max-width="1000">
        <v-card v-if="store.backendError" class="pa-2">
          <v-card-title class="text-center">
            {{ $t("errors.backend.title") }}
          </v-card-title>
          <v-card-text>
            <div class="text-center text-h1">
              <v-icon icon="fas fa-dumpster-fire" class="mb-6"></v-icon>
            </div>
            <div class="mb-4">
              {{ store.backendError.getLocalized($t) }}
            </div>
            <div>{{ $t("errors.backend.sorry") }}</div>
            <div>
              {{
                $t("errors.backend.contact", {
                  mail: "kit-ca-betrieb@scc.kit.edu",
                })
              }}
            </div>
            <div v-if="store.backendError.requestId">
              <div>{{ $t("errors.backend.requestIdHint") }}</div>
              <div class="mt-4">
                <span class="font-weight-bold pr-2">{{ $t("errors.requestIdLabel") }}:</span
                ><span>{{ store.backendError.requestId }}</span>
              </div>
            </div>
          </v-card-text>
          <v-card-actions>
            <v-btn color="secondary" block @click="store.backendError = null">
              {{ $t("dialog.closeButton") }}
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <v-alert
        v-if="showSystemMessage"
        id="system-message"
        :title="$t('systemMessage.title')"
        type="warning"
        density="compact"
        icon="fas fa-triangle-exclamation"
        class="text-left rounded-0 position-fixed w-100"
        style="z-index: 1004"
      >
        {{ $t("systemMessage.message") }}
      </v-alert>
      <div id="system-message-offset"></div>

      <v-fade-transition>
        <v-alert
          v-model="localeNotSupportedAlertShown"
          :title="$t('unsupportedLocale.title')"
          type="info"
          density="compact"
          icon="fas fa-circle-exclamation"
          class="text-left rounded-0"
          closable
        >
          {{
            $t("unsupportedLocale.message", {
              language: new Intl.DisplayNames([String($i18n.fallbackLocale)], { type: "language" }).of($i18n.locale),
              defaultLanguage: new Intl.DisplayNames([String($i18n.fallbackLocale)], { type: "language" }).of(
                String($i18n.fallbackLocale)
              ),
            })
          }}
          <div class="text-center">
            <v-btn
              variant="text"
              class="mt-2"
              href="https://gitlab.kit.edu/kit/kit-ca/ca-portal/-/blob/main/CONTRIBUTE.md"
              target="_blank"
            >
              {{ $t("unsupportedLocale.contribute") }}
            </v-btn>
            <v-btn
              variant="text"
              class="mt-2"
              @click="
                changeLocale(String($i18n.fallbackLocale));
                localeNotSupportedAlertShown = false;
              "
            >
              {{ $t("unsupportedLocale.dontShowAgain") }}
            </v-btn>
          </div>
        </v-alert>
      </v-fade-transition>

      <div class="align-center ma-auto pa-4 pa-sm-8" style="max-width: 1000px">
        <div class="pt-8">
          <router-view />
        </div>
      </div>
    </v-main>
  </v-app>
</template>

<script lang="ts">
import {
  getAssetUrl,
  getLocaleFlagUrl,
  loadAndCheckToken,
  login,
  logout,
  SHOW_SYSTEM_MESSAGE,
  store,
} from "@/ts/common";
import { defineComponent } from "vue";
import { useTheme } from "vuetify";
import { StoreType } from "@/ts/types";
import { Locale } from "vue-i18n";
import { APIError, APIErrorDialogData } from "@/ts/errorTypes";

type LayoutData = {
  localeSvgUrl: string;
  localeSelectMenuOpened: boolean;
  localeNotSupportedAlertShown: boolean;
  apiErrorDialogOpened: boolean;
  backendErrorDialogOpened: boolean;
};

export default defineComponent({
  setup() {
    return {
      theme: useTheme(),
      store: store as StoreType,
      showSystemMessage: SHOW_SYSTEM_MESSAGE,
    };
  },
  data(): LayoutData {
    return {
      localeSvgUrl: "",
      localeSelectMenuOpened: false,
      apiErrorDialogOpened: false,
      backendErrorDialogOpened: false,
      localeNotSupportedAlertShown: false,
    };
  },
  watch: {
    "store.apiErrorDialogData": function (data: APIErrorDialogData | null) {
      this.apiErrorDialogOpened = Boolean(data);
    },
    "store.backendError": function (backendError: APIError | null) {
      this.backendErrorDialogOpened = Boolean(backendError);
    },
    "$i18n.locale": function (newLocale: Locale) {
      this.changeLocale(newLocale);
    },
  },
  beforeMount() {
    this.loadLocale();

    this.store.setTitle(this.$t(`${String(this.$route.name)}.title`));

    // Load theme from localstorage
    let theme = localStorage.getItem("theme");
    if (!theme) {
      if (window.matchMedia && window.matchMedia("(prefers-color-scheme: dark)").matches) {
        theme = "dark";
      } else {
        theme = "light";
      }
    }
    this.updateTheme(theme);

    // Set up resize listener
    window.addEventListener("resize", this.resizeListener);

    // Load user JWT
    loadAndCheckToken();
  },
  beforeUnmount() {
    window.removeEventListener("resize", this.resizeListener);
  },
  mounted() {
    this.resizeListener();
  },
  methods: {
    login,
    logout,
    getLocaleFlagUrl,
    updateTheme: function (newTheme: string | null) {
      if (!newTheme) {
        console.error("Tried to set theme to undefined, this should not happen.");
        return;
      }

      this.theme.global.name.value = newTheme;

      if (this.theme.global.current.value.dark) {
        store.logoUrl = getAssetUrl("logo-inverted.svg");
      } else {
        store.logoUrl = getAssetUrl("logo.svg");
      }

      localStorage.setItem("theme", this.theme.global.name.value);
    },
    loadLocale: function () {
      const locale = localStorage.getItem("locale");
      if (locale) {
        this.changeLocale(locale);
      } else {
        this.changeLocale(this.$i18n.locale);
      }
    },
    changeLocale: function (newLocale: string) {
      if (this.$i18n.availableLocales.includes(newLocale)) {
        this.localeSvgUrl = getLocaleFlagUrl(newLocale);
        this.$i18n.locale = newLocale;
        localStorage.setItem("locale", newLocale);
      } else {
        this.localeSvgUrl = getLocaleFlagUrl(String(this.$i18n.fallbackLocale));
        this.localeNotSupportedAlertShown = true;
      }

      document.querySelector("html")?.setAttribute("lang", this.$i18n.locale);
    },
    resizeListener: function () {
      if (this.showSystemMessage) {
        const systemMessageOffset = document.getElementById("system-message-offset");
        const systemMessage = document.getElementById("system-message");
        if (systemMessageOffset && systemMessage) {
          systemMessageOffset.style.paddingTop = `${systemMessage.offsetHeight}px`;
        }
      }
    },
  },
});
</script>
